;
; OXRAN.asm
; Created: 10.11.2017 14:10:18
; Author : SVShishkin

;   flo
;0  -    1 
;1  -    2 
;2  -    3 
;3  -    4
;4  -    5 
;5  -    6 
;6  -    7
;7  -    8

;   flo1
;0  -    
;1  -    "2",     .
;2  -     h
;3  -   
;4  -       
;5  -    
;6  -     h
;7  -         

.INCLUDE	"2313def.inc"

.DEF	t2=r16
.DEF	t1=r17
.DEF	tec=r18
.DEF	flo=r19
.DEF	sek1=r20
.DEF	regim=r21
.DEF	catod=r22
.DEF	cod=r23
.DEF	SSREG=r24
.DEF	flo1=r25
.equ RAM=$060

.CSEG

.ORG	0
		rjmp	INIT
.ORG	OC1addr
		nop
.ORG	OVF1addr
						
TIM0:	in	 SSREG,SREG;    /1
		dec  sek1		;   
		brne S0
		ldi  sek1,255		
		
EMOS1:	CBR	   flo1,0b00001000		;   
		
EMOS2:	sbrc	flo1,6			;    h  
		rjmp	MOL1
		SBR	    flo1,0b01000000
		rjmp	S0
MOL1:	CBR	    flo1,0b01000000	
	
S0:		ldi  t2,0b11111110;  1
		out  PORTB,t2
		nop
		nop
		nop
		sbic PIND,3
		rjmp S1
		sbrc flo,0
		rjmp ms1
		SBR  flo,0b00000001; 

		sbrc flo1,1
		rjmp DAL1
		
		rjmp ms1	
DAL1:   SBR  flo1,0b10000000
		rjmp ms2
S1:     CBR  flo,0b000000001

		ldi  t2,0b11111101;  2
		out  PORTB,t2
		nop
		nop
		nop
		sbic PIND,3
		rjmp S2
		sbrc flo,1
		rjmp ms1
		SBR  flo,0b00000010;

		sbrc flo1,1
		rjmp DAL2
		
		rjmp ms1	
DAL2:   SBR  flo1,0b10000000
		rjmp ms2
S2:     CBR  flo,0b000000010
				
	    ldi  t2,0b11111011; 3
		out  PORTB,t2
		nop
		nop
		nop
		sbic PIND,3
		rjmp S3
		sbrc flo,2
		rjmp ms1
		SBR  flo,0b00000100; 

		sbrc flo1,1
		rjmp DAL3	
		
		rjmp ms1	
DAL3:   SBR  flo1,0b10000000
		rjmp ms2

S3:     CBR  flo,0b00000100
	
		ldi  t2,0b11110111;  4; 
		out  PORTB,t2	
		nop
		nop
		nop
		sbic PIND,3
		rjmp S4
		sbrc flo,3
		rjmp ms1
		SBR  flo,0b00001000;

		sbrc flo1,1
		rjmp DAL4
		
		rjmp ms1	
DAL4:   SBR  flo1,0b10000000
		rjmp ms2

S4:		CBR  flo,0b00001000
		
		ldi  t2,0b11101111;  5; 
		out  PORTB,t2	
		nop
		nop
		nop
		sbic PIND,3
		rjmp S5
		sbrc flo,4
		rjmp ms1
		SBR  flo,0b00010000; 

		sbrc flo1,1
		rjmp DAL5
		
		rjmp ms1	
DAL5:   SBR  flo1,0b10000000
		rjmp ms2
S5:		CBR  flo,0b00010000

		ldi  t2,0b11011111;  6
		out  PORTB,t2	
		nop
		nop
		nop
		sbic PIND,3
		rjmp S6
		sbrc flo,5
		rjmp ms1
		SBR  flo,0b00100000; 

		sbrc flo1,1
		rjmp DAL6
		rjmp ms1	
DAL6:   SBR  flo1,0b10000000
		rjmp ms2

S6:		CBR  flo,0b00100000

		ldi  t2,0b10111111;  7
		out  PORTB,t2	
		nop
		nop
		nop
		sbic PIND,3
		rjmp S7
		sbrc flo,6
		rjmp ms1
		SBR  flo,0b01000000		
		
		sbrc flo1,1
		rjmp DAL7
	
		rjmp ms1	
DAL7:   SBR  flo1,0b10000000
		rjmp ms2
S7:		CBR  flo,0b01000000

		ldi  t2,0b01111111; 8    .
		out  PORTB,t2	
		nop
		nop
		nop
		sbic PIND,3
		rjmp S8
		sbrc flo,7
		rjmp ms1
		SBR  flo,0b10000000

		inc  regim
		CPI  regim,3
		brne DAL9
		ldi  regim,1	
		rjmp DAL71

DAL9:	CPI  regim,1
		brne DAL8
		
DAL71:	ldi  tec,1
		sts	 $60,tec
		ldi  tec,20
		sts	 $61,tec
		;CBR  flo1,0b00000001 ;      
		SBR  flo1,0b00100100 ;   h
		CBR  flo1,0b10010011;ldi flag,1
		sbi  PORTD,0;   1
		sbi  PORTD,2;   
		sbi  PORTD,6;   2
		rjmp ms1
DAL8:	CPI  regim,2
		brne ms1
		Ldi  tec,9
		sts	 $60,tec
		sts	 $61,tec
		CBR  flo1,0b00100000 ;   
		rjmp ms1
S8:		CBR  flo,0b10000000 
		rjmp ms1

ms2:	sbrc flo1,4
		rjmp ms1
		Ldi  tec,2;    
		sts	 $60,tec
		sts	 $61,tec
		SBR  flo1,0b00010000 

ms1:	sbi PORTD,4
		sbi PORTD,5
		lsl catod
		sbrs catod,3
		brne	m1
		ldi	catod, 1

m1:		ldi	YL,low(RAM)
		ldi	YH,high(RAM)
		
		sbrs catod,1
		rjmp  m2
		adiw YL,0
		cbi PORTD,4
		rjmp  m4				
m2:		sbrs catod,2
		rjmp  m4
		adiw YL,1
		cbi PORTD,5
m4:		ld cod,Y
		CPI  cod,0
		brne m10
		ldi  t1,0b11000000
m10:	CPI  cod,1
		brne m11
		ldi  t1,0b11111001
m11:	CPI  cod,2
		brne m12
		ldi  t1,0b10100100
m12:	CPI  cod,3
		brne m13
		ldi  t1,0b10110000
m13:	CPI  cod,4
		brne m14
	    ldi  t1,0b10011001
m14:	CPI  cod,5
		brne m15
		ldi  t1,0b10010010
m15:	CPI  cod,6
		brne m16
		ldi  t1,0b10000010
m16:	CPI  cod,7
		brne m17
		ldi  t1,0b11111000
m17:	CPI  cod,8
		brne m18
		ldi  t1,0b10000000
m18:	CPI  cod,9
		brne m19
		ldi  t1,0b10010000
m19:	CPI  cod,10
		brne m20
		ldi  t1,0b11111110
m20:	CPI  cod,11
		brne m21
		ldi  t1,0b11111101
m21:	CPI  cod,12
		brne m22
		ldi  t1,0b11111011
m22:	CPI  cod,13
		brne m23
		ldi  t1,0b11110111
m23:	CPI  cod,14
		brne m24
		ldi  t1,0b11101111
m24:	CPI  cod,15
		brne m25
		ldi  t1,0b11011111
m25:	CPI  cod,16
		brne m26
		ldi  t1,0b10111111
m26:	CPI  cod,20         ; ,       
		brne m27
		ldi  t1,0b11111111
m27:	out  PORTB,t1

		;   h    
		sbrc	flo1,6			;:    ?
		rjmp	m40
		sbrs	catod,1		;:   ?
		rjmp	m30
		sbrc	flo1,2		;:     h  
;
		rjmp	m30
		sbis	PORTB,7		;   PB7,./.  h    
		rjmp	m201
		cbi	    PORTB,7
		rjmp	m30
m201:	sbi	    PORTB,7
;  / 
m30:	CPI    regim,1
		brne   m40
		
		sbrs	catod,2		;:   ?
		rjmp	m40
		sbrs	flo,0		;:  1 
		rjmp	m31
		sbis	PORTB,0		;   PB7,./.  h    
		rjmp	m202
		cbi	    PORTB,0
		rjmp	m40
m202:	sbi	    PORTB,0
		rjmp	m40
m31:    sbrs	flo,1		;:  2 
		rjmp	m32
		sbis	PORTB,1		;   PB7,./.  h    
		rjmp	m203
		cbi	    PORTB,1
		rjmp	m40
m203:	sbi	    PORTB,1
		rjmp	m40

m32:    sbrs	flo,2		;:  3 
		rjmp	m33
		sbis	PORTB,2		;   PB7,./.  h    
		rjmp	m204
		cbi	    PORTB,2
		rjmp	m40
m204:	sbi	    PORTB,2
		rjmp	m40

m33:    sbrs	flo,3		;:  4 
		rjmp	m34
		sbis	PORTB,3		;   PB7,./.  h    
		rjmp	m205
		cbi	    PORTB,3
		rjmp	m40
m205:	sbi	    PORTB,3
		rjmp	m40

m34:    sbrs	flo,4		;:  5 
		rjmp	m35
		sbis	PORTB,4		;   PB7,./.  h    
		rjmp	m206
		cbi	    PORTB,4
		rjmp	m40
m206:	sbi	    PORTB,4
		rjmp	m40

m35:    sbrs	flo,5		;:  6 
		rjmp	m36
		sbis	PORTB,5		;   PB7,./.  h    
		rjmp	m207
		cbi	    PORTB,5
		rjmp	m40
m207:	sbi	    PORTB,5
		rjmp	m40

m36:    sbrs	flo,6		;:  6 
		rjmp	m40
		sbis	PORTB,6		;   PB7,./.  h    
		rjmp	m208
		cbi	    PORTB,6
		rjmp	m40
m208:	sbi	    PORTB,6
		
m40:	out	SREG,SSREG
		reti

INIT:	ldi  sek1,255
		ldi  regim,1
		clr	 flo
		CBR  flo1,0b10010011;ldi flag,1
		SBR  flo1,0b00100100

		ldi catod,1
		ldi	r30,$DF
        out	SPL,r30
						
		ldi	r30,$FF		;     B  D
		out	DDRB,r30
		out	PORTB,r30
		ldi	r30,0b11111111	
		out PORTD,r30
		ldi	r30,0b11110101	
		out DDRD,r30

		sbi  PORTD,6

		ldi	r30,12		;   0    
		out	TCCR1B,r30
		ldi	r30,0
		out	OCR1AH,r30
		ldi	r30,$10      ;$64
		out	OCR1AL,r30				
		ldi	r30,$C0
		out	TIMSK,r30
		ldi	YL,low(RAM)
		ldi	YH,high(RAM)		
		ldi cod,1		;1
		st	Y+,cod
		ldi cod,20		; 
		st	Y+,cod
		sei

SE1:    sbrc flo1,3;	;  ?
		rjmp SE1
		SBR  flo1,0b00001000

		sbis PIND,1 ;  
		rjmp trevog

		CPI regim,2
		brne SE1

		sbrc flo1,7;	      ?
		rjmp EMMNS1

		sbrc flo1,5;	       ?
		rjmp SE1
				
EMMN1:	ldi	 YL,low(RAM)
		ldi	 YH,high(RAM)			
		ld   tec,Y+
		CPI  tec,0
		brne SOK1
		ld   tec,Y+
		CPI  tec,0
		brne SOK1
		rjmp SE1;MIN11

SOK1:	ldi	 YL,low(RAM)
		ldi	 YH,high(RAM)			
		ld   tec,Y
		dec	 tec
		CPI  tec,255
		brne SOK11
		ldi  tec,9
		st	 Y+,tec
		rjmp SOK2
SOK11:  st   Y,tec
		rjmp MIN

SOK2:   ld   tec,Y
		dec	 tec
		CPI  tec,255
		brne SOK21
		ldi  tec,9
		st	 Y+,tec
		rjmp MIN
SOK21:	st   Y,tec
		rjmp MIN

MIN:    ldi	 YL,low(RAM)
		ldi	 YH,high(RAM)			
		ld   tec,Y+
		CPI  tec,0
		brne SE1 ;MIN11
		ld   tec,Y+
		CPI  tec,0
		brne SE1; MIN11
	
		SBR  flo1,0b00100000  ;  
		SBR  flo1,0b00000010  ; 
		CBR  flo1,0b00000100  ;  
		Ldi  tec,2
		sts	 $60,tec
		ldi  tec,20
		sts	 $61,tec
		rjmp  SE1
							
;    				
EMMNS1:	sbrs flo1,0;	  ?
		rjmp EMNNN1
trevog:	cbi  PORTD,0;   1
		cbi  PORTD,2;   

		cbi  PORTD,6
		sbic PIND,6 ;   2
		rjmp MILS6
		sbi  PORTD,6
		rjmp SE1		
MILS6:	cbi  PORTD,6
		rjmp SE1

EMNNN1:	ldi	 YL,low(RAM)
		ldi	 YH,high(RAM)			
		ld   tec,Y+
		CPI  tec,0
		brne SOKS1
		ld   tec,Y+
		CPI  tec,0
		brne SOKS1
SE111:	rjmp SE1;MINS11

SOKS1:	ldi	 YL,low(RAM)
		ldi	 YH,high(RAM)			
		ld   tec,Y
		dec	 tec
		CPI  tec,255
		brne SOKS11
		ldi  tec,9
		st	 Y+,tec
		rjmp SOKS2
SOKS11: st   Y,tec
		rjmp MINS

SOKS2:  ld   tec,Y
		dec	 tec
		CPI  tec,255
		brne SOKS21
		ldi  tec,9
		st	 Y+,tec
		rjmp MINS
SOKS21:	st   Y,tec
		;rjmp MINS
MINS:   ldi	 YL,low(RAM)
		ldi	 YH,high(RAM)			
		ld   tec,Y+
		CPI  tec,0
		brne SE111
		ld   tec,Y+
		CPI  tec,0
		brne SE111
		SBR  flo1,0b10000000;   
		SBR  flo1,0b00000001;   
		Ldi  tec,3
		sts	 $60,tec
		ldi  tec,20
		sts	 $61,tec
		rjmp SE1
.EXIT



